//
//  WDWardrobeViewController.h
//  Wardrobe
//
//  Created by Tim Storey on 19/05/2011.
//

#import <UIKit/UIKit.h>
#import <QuartzCore/QuartzCore.h>
#import "WDView.h"

#define CENTER_OUTFIT_PNL_X 795.0
#define CENTER_OUTFIT_PNL_Y 370.0
#define MAX_NO_DRAGGABLE_ITEMS 20

@interface WDWardrobeViewController : UIViewController {
    CABasicAnimation *posAnimation;
    WDView *mainView;
    UIImage *img;
    UITapGestureRecognizer *tap;
    UITapGestureRecognizer *tap2;
    UIPanGestureRecognizer *pan;
    BOOL drawOpen;
    CGPoint startPoint;
    CGRect startFrame;
    CGRect newFrame;
    CGPoint layerPosition;
    NSMutableDictionary *startPositions;
    NSMutableArray *imagesForView;
}

- (id)init;

- (void)addAnimationToLayer:(CAAnimation *)anim layer:(UIView *)layer tag:(PictureTypes)tag;

- (CGPoint)getPositionForLayerInSubview:(UIView *)containingView tag:(PictureTypes)tag;

- (void)setPositionForLayerInSubview:(UIView *)containingView pos:(CGPoint)pos tag:(PictureTypes)tag;

- (CGPoint)getCenterForLayerInSubviews:(UIView *)containingView tag:(PictureTypes)tag;

- (void)fadeInLayerInSubview:(UIView *)containingView tag:(PictureTypes)tag timeForFade:(CGFloat)timeForFade;

- (void)fadeOutLayerInSubview:(UIView *)containingView tag:(PictureTypes)tag timeForFade:(CGFloat)timeForFade;

- (void)setLayerInSubviewHidden:(UIView *)view tag:(PictureTypes)tag;

- (void)setLayerInSubviewVisible:(UIView *)view tag:(PictureTypes)tag;

- (void)addRecogniserToViewInSubviews:(UIView *)view recogniser:(UIGestureRecognizer *)recogniser tag:(PictureTypes)tag;

- (void)setViewInSubviewUserEnabled:(UIView *)containingView tag:(PictureTypes)tag;

- (void)tapHandler:(UITapGestureRecognizer *)sender;

- (void)panHandler:(UIPanGestureRecognizer *)sender;

@end
