//
//  WDWardrobeViewController.m
//  Wardrobe
//
//  Created by Tim Storey on 19/05/2011.
//

#import "WDWardrobeViewController.h"
#import "commons.h"

@implementation WDWardrobeViewController

#pragma mark Memory Management

- (void)dealloc
{
    [startPositions release];
    [pan release];
    [tap release];
    [img release];
    [mainView release];
    [posAnimation release];
    [super dealloc];
}

#pragma mark Initialisation

- (void)doInit {

    img = [UIImage imageNamed:@"background_wall.png"];
    mainView = [[WDView alloc] initWithImage:img];
    [self.view addSubview:mainView];
}

- (id)init {
    self = [super init];
    if (self) {
        [self doInit];
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    NSLog(@"Memory Warning...");
    [super didReceiveMemoryWarning];    
}


- (void)createAllNonInteractiveElements {
    
    img = [UIImage imageNamed:@"hatbox_upper.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(490, 0) tag:HATBOX_UPPER];
    
    img = [UIImage imageNamed:@"wardrobe_middle.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(100, 48) tag:WARDROBE_MIDDLE];
    
    img = [UIImage imageNamed:@"doors_left.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(50, 20) tag:DOOR_LEFT];
    
    img = [UIImage imageNamed:@"doors_right.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(650, 40) tag:DOOR_RIGHT];
    
    img = [UIImage imageNamed:@"dress.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(390, 150) tag:DRESS];
    
    img = [UIImage imageNamed:@"bags.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(200, 140) tag:BAGS];
    
    img = [UIImage imageNamed:@"shoes.png"]; 
    [mainView addImageAtPositionWithTag:img position:CGPointMake(390, 520) tag:SHOES];
    
    img = [UIImage imageNamed:@"buythisoutfit-button.png"];
    [mainView addImageAtPositionWithTag:img position:CGPointMake(850, 25) tag:BUY_THIS];
    [self setLayerInSubviewHidden:mainView tag:BUY_THIS];
    
}

- (void)createAllInteractiveElements {
    
    
    img = [UIImage imageNamed:@"shelve_open-button.png"];
    [mainView addImageAtPositionWithTag:img position:CGPointMake(190, 500) tag:DRAWER_OPEN];
    [self setLayerInSubviewHidden:mainView tag:DRAWER_OPEN];
    
    img = [UIImage imageNamed:@"shirt2.png"];
    [mainView addImageAtPositionWithTag:img position:CGPointMake(100, 230) tag:SHIRT_PURPLE];
    [self setLayerInSubviewHidden:mainView tag:SHIRT_PURPLE];
    layerPosition = CGPointMake(100, 230);
    [startPositions setObject:[NSValue valueWithCGPoint:layerPosition] forKey:[NSString stringWithFormat:@"%d", SHIRT_PURPLE]];
    
    img = [UIImage imageNamed:@"shirt3.png"];
    [mainView addImageAtPositionWithTag:img position:CGPointMake(280, 200) tag:SHIRT_GREEN];
    [self setLayerInSubviewHidden:mainView tag:SHIRT_GREEN];
    layerPosition = CGPointMake(280, 200);
    [startPositions setObject:[NSValue valueWithCGPoint:layerPosition] forKey:[NSString stringWithFormat:@"%d", SHIRT_GREEN]];
    
    img = [UIImage imageNamed:@"shirt4.png"];
    [mainView addImageAtPositionWithTag:img position:CGPointMake(150, 130) tag:SHIRT_BLUE];
    [self setLayerInSubviewHidden:mainView tag:SHIRT_BLUE];
    layerPosition = CGPointMake(150, 130);
    [startPositions setObject:[NSValue valueWithCGPoint:layerPosition] forKey:[NSString stringWithFormat:@"%d", SHIRT_BLUE]];
    
    img = [UIImage imageNamed:@"shirt1.png"];
    [mainView addImageAtPositionWithTag:img position:CGPointMake(210, 325) tag:SHIRT_RED];
    [self setLayerInSubviewHidden:mainView tag:SHIRT_RED];
}

- (void)createAllAnimations{
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:WARDROBE_MIDDLE];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x, layerPosition.y - 1000)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = .5;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:WARDROBE_MIDDLE];
    [self addAnimationToLayer:posAnimation layer:mainView tag:WARDROBE_MIDDLE];
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:DOOR_LEFT];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x - 1000, layerPosition.y)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = .8;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:DOOR_LEFT];
    [self addAnimationToLayer:posAnimation layer:mainView tag:DOOR_LEFT];
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:DOOR_RIGHT];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x + 2000, layerPosition.y)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = 1;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:DOOR_RIGHT];
    [self addAnimationToLayer:posAnimation layer:mainView tag:DOOR_RIGHT];
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:HATBOX_UPPER];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x, layerPosition.y - 1000)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = 1;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:HATBOX_UPPER];
    [self addAnimationToLayer:posAnimation layer:mainView tag:HATBOX_UPPER];
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:BAGS];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x, layerPosition.y - 1000)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = .7;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:BAGS];
    [self addAnimationToLayer:posAnimation layer:mainView tag:BAGS];
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:SHOES];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x, layerPosition.y - 1500)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = 1.1;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:SHOES];
    [self addAnimationToLayer:posAnimation layer:mainView tag:SHOES];
    
    layerPosition = [self getPositionForLayerInSubview:mainView tag:DRESS];
    [posAnimation setFromValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x, layerPosition.y - 1500)]];
    [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
    posAnimation.duration = 1.2;
    [self setPositionForLayerInSubview:mainView pos:layerPosition tag:DRESS];
    [self addAnimationToLayer:posAnimation layer:mainView tag:DRESS];
}

- (void)createAllGestures {
    
    tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapHandler:)];
    [self addRecogniserToViewInSubviews:mainView recogniser:tap tag:WARDROBE_MIDDLE];
    [self setViewInSubviewUserEnabled:mainView tag:WARDROBE_MIDDLE];
    
    //for debug
    tap2 = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapHandler:)];
    [self addRecogniserToViewInSubviews:mainView recogniser:tap2 tag:DOOR_RIGHT];
    [self setViewInSubviewUserEnabled:mainView tag:DOOR_RIGHT];
    
    pan = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(panHandler:)];
    [self addRecogniserToViewInSubviews:mainView recogniser:pan tag:SHIRT_BLUE];
    [self setViewInSubviewUserEnabled:mainView tag:SHIRT_BLUE];
    
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{   
    [super viewDidLoad];
    
    startPositions = [[NSMutableDictionary alloc] init];
    drawOpen = NO;
    layerPosition = CGPointZero;
    posAnimation = [[CABasicAnimation animationWithKeyPath:@"position"] retain];
    
    [self createAllNonInteractiveElements];
    
    [self createAllInteractiveElements];

    [self createAllAnimations];
    
    [self createAllGestures];
    
//    layerPosition = CGPointMake(100, 230);
//    [startPositions setValue:[NSValue valueWithCGPoint:layerPosition] forKey:[NSString stringWithFormat:@"%d", SHIRT_PURPLE]];
    
}


- (void)viewDidUnload
{
    [super viewDidUnload];
}

#pragma mark Animation Methods

- (void)addAnimationToLayer:(CAAnimation *)anim layer:(UIView *)layer tag:(PictureTypes)tag {
    
    for (UIImageView *iv in layer.subviews) {
        if ([iv tag] == tag) {
            [iv.layer addAnimation:anim forKey:nil];
            
        }
    }

}

- (void)setLayerInSubviewHidden:(UIView *)view tag:(PictureTypes)tag {
    for (UIImageView *iv in view.subviews) {
        if ([iv tag] == tag) {
            [iv setHidden:YES];
            [iv setAlpha:0];
        }
    }
}

- (void)setLayerInSubviewVisible:(UIView *)view tag:(PictureTypes)tag {
    for (UIImageView *iv in view.subviews) {
        if ([iv tag] == tag) {
            [iv setHidden:NO];
            [iv setAlpha:1];
        }
    }
}

- (void)fadeInLayerInSubview:(UIView *)containingView tag:(PictureTypes)tag timeForFade:(CGFloat)timeForFade {
    for (UIImageView *iv in containingView.subviews) {
        if ([iv tag] == tag) {
            [iv setHidden:NO];
            [iv setAlpha:0];
            [UIView animateWithDuration:timeForFade 
                                  delay:0 
                                options:UIViewAnimationOptionCurveEaseIn 
                             animations:^{
                                 [iv setAlpha:1];
                             }
                             completion:NULL];
            
        }
    }
}

- (void)fadeOutLayerInSubview:(UIView *)containingView tag:(PictureTypes)tag timeForFade:(CGFloat)timeForFade {
    
    __block WDWardrobeViewController *blockSelf = self;
    
    for (UIImageView *iv in containingView.subviews) {
        if ([iv tag] == tag) {
            //[iv setAlpha:1];
            [UIView animateWithDuration:timeForFade 
                                  delay:0 
                                options:UIViewAnimationOptionCurveEaseIn 
                             animations:^{
                                 [iv setAlpha:0];
                             }
                             completion:^(BOOL finished) {
                                 [blockSelf setLayerInSubviewHidden:mainView tag:tag];
                             }];            
        }
    }
}

- (CGPoint)getPositionForLayerInSubview:(UIView *)containingView tag:(PictureTypes)tag {
    CGPoint tmp = CGPointZero;
    for ( UIImageView *iv in containingView.subviews) {
        if ([iv tag] == tag) {
            tmp = iv.layer.position;
        }
    }
    return tmp;
}

- (void)setPositionForLayerInSubview:(UIView *)containingView pos:(CGPoint)pos tag:(PictureTypes)tag {
    for (UIImageView *iv in containingView.subviews) {
        if ([iv tag]==tag){
            NSLog(@"old layer position: %f %f",iv.layer.position.x, iv.layer.position.y);
            [iv.layer setPosition:pos];
            NSLog(@"new layer position: %f %f",iv.layer.position.x, iv.layer.position.y);
        }
    }
}

- (CGPoint)getCenterForLayerInSubviews:(UIView *)containingView tag:(PictureTypes)tag {
    CGPoint tmp = CGPointZero;
    for ( UIImageView *iv in containingView.subviews) {
        if ([iv tag] == tag) {
            tmp = iv.center;
        }
    }
    return tmp;
}


#pragma mark Gesture Recogniser Methods

- (void)setViewInSubviewUserEnabled:(UIView *)containingView tag:(PictureTypes)tag {
    
    for (UIImageView *iv in containingView.subviews) {
        if ([iv tag] == tag) {
            [iv setUserInteractionEnabled:YES];
        }
    }
}

- (void)addRecogniserToViewInSubviews:(UIView *)view recogniser:(UIGestureRecognizer *)recogniser tag:(PictureTypes)tag {

    for (UIImageView *iv in view.subviews) {
        if ([iv tag] == tag) {
            [iv addGestureRecognizer:recogniser];
        }
    }
}

- (void)panHandler:(UIPanGestureRecognizer *)sender {
    NSLog(@"Panning...");
    
    CGPoint trans;
    CGPoint centerPoint = CGPointMake(795, 370);//center of mirror
    
    switch (pan.state) {
        case UIGestureRecognizerStateBegan:
            startPoint = [sender translationInView:self.view];
            startFrame = sender.view.frame;
            newFrame = sender.view.frame;
            NSLog(@"began");
            break;
        case UIGestureRecognizerStateChanged:
            trans = [sender translationInView:self.view];
            newFrame.origin.x = startFrame.origin.x + trans.x;
            newFrame.origin.y = startFrame.origin.y + trans.y;
            sender.view.frame = newFrame;
            NSLog(@"changing");
            break;
        case UIGestureRecognizerStateEnded:
            if (((sender.view.frame.origin.x > 670) && (sender.view.frame.origin.x < 920)) && ( (sender.view.frame.origin.y < 650) && (sender.view.frame.origin.y > 80) ) ) {
                if ([sender.view tag] == SHIRT_BLUE) {
                    [posAnimation setFromValue:[sender.view.layer valueForKey:@"position"]];
                    [posAnimation setToValue:[NSValue valueWithCGPoint:centerPoint]];
                    [posAnimation setDuration:0.15];
                    
                    [sender.view.layer setPosition:centerPoint];
                    [sender.view.layer addAnimation:posAnimation forKey:@"position"];

                    [self fadeInLayerInSubview:mainView tag:BUY_THIS timeForFade:.5];
                    break;
                }
            }
            sender.view.frame = newFrame;
            NSLog(@"ended");
            break;
        default:
            break;
    }
}

- (void)tapHandler:(UITapGestureRecognizer *)sender {
    BOOL inDrawer = NO;
    
    if (sender.state == UIGestureRecognizerStateEnded) {
        CGPoint currPosition = [sender locationInView:mainView];
        NSLog(@"X: %f Y:%f",currPosition.x, currPosition.y);
        
        if ( ( (currPosition.x < 362) && (currPosition.x > 195) ) && ( (currPosition.y < 554) && (currPosition.y > 504) ) ) {
            inDrawer = YES;
        }
    }
    
    if (inDrawer && !(drawOpen)) {
        drawOpen = YES;
        CGPoint start= CGPointMake(278, 400);
        [self setLayerInSubviewVisible:mainView tag:DRAWER_OPEN];
        [self setLayerInSubviewVisible:mainView tag:SHIRT_RED];
        [self setLayerInSubviewVisible:mainView tag:SHIRT_BLUE];
        [self setLayerInSubviewVisible:mainView tag:SHIRT_GREEN];
        [self setLayerInSubviewVisible:mainView tag:SHIRT_PURPLE];
        
        
        NSValue *tmp = [startPositions objectForKey:[NSString stringWithFormat:@"%d", SHIRT_BLUE]];
        layerPosition = [tmp CGPointValue];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:start]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:layerPosition tag:SHIRT_BLUE];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_BLUE];
        
        
        tmp = [startPositions objectForKey:[NSString stringWithFormat:@"%d", SHIRT_GREEN]];
        layerPosition = [tmp CGPointValue];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:start]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:layerPosition tag:SHIRT_GREEN];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_GREEN];
        
        tmp = [startPositions objectForKey:[NSString stringWithFormat:@"%d", SHIRT_PURPLE]];
        layerPosition = [tmp CGPointValue];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:start]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:layerPosition]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:layerPosition tag:SHIRT_PURPLE];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_PURPLE];
    }
    else if (inDrawer && drawOpen) {
        CGPoint start= CGPointMake(278, 400);
        NSLog(@"opened now close me and put the shirts away");
        
        
        layerPosition = [self getPositionForLayerInSubview:mainView tag:SHIRT_BLUE];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:layerPosition]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:start]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:start tag:SHIRT_BLUE];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_BLUE];
        [self fadeOutLayerInSubview:mainView tag:SHIRT_BLUE timeForFade:.3];
        
        layerPosition = [self getPositionForLayerInSubview:mainView tag:SHIRT_GREEN];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:layerPosition]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:start]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:start tag:SHIRT_GREEN];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_GREEN];
        [self fadeOutLayerInSubview:mainView tag:SHIRT_GREEN timeForFade:.3];
        
        layerPosition = [self getPositionForLayerInSubview:mainView tag:SHIRT_PURPLE];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:layerPosition]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:start]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:start tag:SHIRT_PURPLE];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_PURPLE];
        [self fadeOutLayerInSubview:mainView tag:SHIRT_PURPLE timeForFade:.3];
        
        layerPosition = [self getPositionForLayerInSubview:mainView tag:SHIRT_RED];
        [posAnimation setFromValue:[NSValue valueWithCGPoint:layerPosition]];
        [posAnimation setToValue:[NSValue valueWithCGPoint:CGPointMake(layerPosition.x, layerPosition.y + 50)]];
        posAnimation.duration = .2;
        [self setPositionForLayerInSubview:mainView pos:start tag:SHIRT_RED];
        [self addAnimationToLayer:posAnimation layer:mainView tag:SHIRT_RED];
        [self fadeOutLayerInSubview:mainView tag:SHIRT_RED timeForFade:.3];
        
        drawOpen = NO;
    }
    
}


#pragma mark Orientation Methods

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    //    return YES;
    return UIInterfaceOrientationIsLandscape(interfaceOrientation);
}

@end
